// **** URBI Engine ****
// umake-engine -o engine-joystick joystick_urbi.cc joystick_gtkmm.cc EXTRA_CPPFLAGS="-D_REENTRANT -I/usr/include/gtkmm-2.4 -I/usr/lib/gtkmm-2.4/include -I/usr/include/glibmm-2.4 -I/usr/lib/glibmm-2.4/include -I/usr/include/gdkmm-2.4 -I/usr/lib/gdkmm-2.4/include -I/usr/include/pangomm-1.4 -I/usr/include/atkmm-1.6 -I/usr/include/gtk-2.0 -I/usr/include/sigc++-2.0 -I/usr/lib/sigc++-2.0/include -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -I/usr/lib/gtk-2.0/include -I/usr/include/cairomm-1.0 -I/usr/include/pango-1.0 -I/usr/include/cairo -I/usr/include/freetype2 -I/usr/include/directfb -I/usr/include/libpng12 -I/usr/include/pixman-1 -I/usr/include/atk-1.0" EXTRA_LDFLAGS="-lgtkmm-2.4 -lgdkmm-2.4 -latkmm-1.6 -lgtk-x11-2.0 -lpangomm-1.4 -lcairomm-1.0 -lglibmm-2.4 -lsigc-2.0 -lgdk-x11-2.0 -latk-1.0 -lgdk_pixbuf-2.0 -lm -lpangocairo-1.0 -lpango-1.0 -lcairo -lgobject-2.0 -lgmodule-2.0 -ldl -lglib-2.0 -lboost_thread"
//

#ifndef __JOYSTICK_URBI_H
#define __JOYSTICK_URBI_H

#include <urbi/uobject.hh>
#include "joystick_gtkmm.h"
#include "gtk_urbi.h"

/**
 * Allow the creation of GTK based virtual Joystick in a urbi engine or remote.
 *
 * The joystick can be hidden or shown, has 2 dimension (x_axis and y_axis) and
 * it can be recentred or not when "released" (see JoystickGTKMM).
 */
class JoystickURBI : public urbi::UObject
{
 public:
  /**
   * @name Creation/Destruction
   */
  /**
   * At creation, a Gtk::Main will be created if not existing.
   * Then 'init' is binded into URBI.
   */
  JoystickURBI(const std::string &name);
  /**
   * Destruction, that tries to clear up every Gtk::Widget.
   */
  ~JoystickURBI();
  //@}

  /**
   * Create a JoystickGTKMM of the given name and shows it in a independant thread.
   * A Timer is created that update the value of x_axis and y_axis.
   */
  int init(const std::string &name);
  /**
   * Called by the Timer at the BEGINNING of each URBI Cycle.
   */
  int frequent(void);

  /**
   * Show up the Joystick.
   * Can take some time and seems to be sometimes dependant on event
   * generated by the X system.
   */
  void show();
  /**
   * Hide the Joystick.
   */
  void hide();

 protected:
  /**
   * Create the JoystickGTKMM and its Gtk::Window.
   */
  void create_joystick();
  /**
   * Called in a independant thread, this shows up the JoystickGTKMM.
   */
  void run_joystick();

 protected:
  /**
   * @name internal
   *
   * Internal variables for the joystick.
   */
  /** is the setupp of the internal variables finished ? */
  bool _setup_complete;
  /** variable for the x_axis. */
  urbi::UVar *_var_x_axis;
  /** variable for the y_axis. */
  urbi::UVar *_var_y_axis;
  //@}
  /** A JoystickGTKMM. */
  JoystickGTKMM *_joy;
  /** Gtk::Window to display JoystickGTKMM. */
  Gtk::Window * _win;
  /** Name displayed in the JoystickGTKMM. */
  std::string _name_joy;

  /** The Gtk package that must be initialized. */
  GtkURBI *_gtk_urbi;
};

#endif //__JOYSTICK_URBI_H
